--===========================================================||
---------------------------
--  Stun Grenade Script  --
--------------------------
-- Made by: AmflicKt / eJ z --
--    Released: 09/03/11    --
--	USDE ID : 4161	    --


-- * DESC: Makes the Gas Grenade (default- Gas Grenade) slow
--an enemy or person when they are hit in the grenade's AOE. However
--since this is pretty unfair, i've also changed the damage of the Gas
--Grenade to an Low amount, so that enemies or players that are hit have
--more of a decent advantage. People who are Stunned cannot talk (including
--Team), Plant, Defuse, Build, and Buy. They also get lose their sight the
--longer they are in the AoE.

--___________________--
--* UPDATES *	     --
--___________________--

-- None so far, please find some bugs and errors.
-- Thank you all

--===========================================================||

-- Change these to whatever fits your mind


parse('mp_wpndmg GasGrenade 2')

stunned={}


addhook("spawn","Stun_OnSpawn")
addhook("hit","Stun_Hit")
addhook("say","Stun_SayDisabled")
addhook("sayteam","Stun_SayDisabled")
addhook("buy","Stun_BuyDisabled")
addhook("buildattempt","Stun_BuildDisabled")
addhook("bombplant","Stun_PlantDisabled")
addhook("bombdefuse","Stun_BombDisabled")



function Stun_OnSpawn(id)
--	parse('equip '..id..' 72')	-- Have Stun Grenade on Spawn
	stunned[id] = nil
end

function Stun_Hit(id, source, weapon)
x = player(id,"x")
y = player(id,"y")
	if ( weapon == 72 ) then
		if (player(source,"team")) ~= (player(id,"team")) then	-- Cannot Friendly Fire + Hit Yourself (Enabled)
--		if (player(source,"name")) ~= (player(id,"name")) then	-- Can Friendly Fire, but not Hit / Effect Yourself
			stunned[id] = 5
			parse('speedmod '..id..' -15')
			parse('shake '..id..' 3')
			parse('flashplayer '..id..' 13')
			parse('hudtxt2 '..id..' 49 "255060060Stunned" 11 393')
			timer((stunned[id]*500),"Stun_Free",id)	
		end
	end
end

function Stun_SayDisabled(id, message)
	if (stunned[id] ~= nil) then
		msg2(id,"200200200You are Stunned.")
		return 1
	end
end		

function Stun_BuyDisabled(id)
	if (stunned[id] ~= nil) then
		msg2(id,"200200200You cannot buy when you are Stunned.")
		return 1
	end
end

function Stun_BuildDisabled(id, type, x, y)
	if (stunned[id] ~= nil) then
		msg2(id,"200200200You cannot build when you are Stunned.")
	return 1
	end
end

function Stun_PlantDisabled(id, x, y)
	if (stunned[id] ~= nil) then
		msg2(id,"200200200You cannot plant the Bomb when you are Stunned.")
	return 1
	end
end

function Stun_BombDisabled(id)
	if (stunned[id] ~= nil) then
		msg2(id,"200200200You cannot defuse the Bomb when you are Stunned.")
	return 1
	end
end

function Stun_Free(id)
	stunned[id] = nil
	parse('hudtxt2 '..id..' 49')
	parse("speedmod "..id.." 0")
end



print ("AmflicKt's Stun Grenade Script = Loaded !")